<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="modal">
        <div class="modal-mask"></div> 
        <button class="close-btn button-icon" @click="closeModal();">
            <i class="icon-close"></i>
        </button>
        <div class="modal-wrapper">
            <div class="modal-sidebar">
                <div>
                    <h2 v-if="isEditMode">Edit <br>Glossary</h2>
                    <h2 v-else>Create <br>New <br>Glossary</h2>
                    <div>
                        <nav>
                            <ul>
                                <li :class="{ 'active': currentStep === 1 }"><div><span>1</span>Glossary Info</div></li>
                                <li :class="{ 'active': currentStep === 2 }"><div><span>2</span>Confirmation</div></li>
                            </ul>
                        </nav>
                    </div>
                </div>
                <div>
                    <div class="info user">
                        <h3>Owner</h3>
                        <UserProfile />
                    </div>
                    <InfoBox title="Creation date" text="17:14:12 <br> 19 Nov 2024" />
                </div>
            </div>
            <div class="modal-content">
                <!-- ==== STEP 1 - Glossary Info ====  -->
                <div id="step-1" class="step" v-show="currentStep === 1">
                    <form id="glossary-step-1" @submit.prevent="handleSubmit">
                        <div class="title">
                            <span class="step-number">1</span>
                            <h2>Glossary info</h2>
                            <p>Develop a new glossary to group and standardize terms relevant to your datasets. Provide
                                a clear and comprehensive name and description to facilitate consistent terminology
                                usage.</p>
                        </div>
                        <div class="step-border">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>1.</span>Glossary name</label>
                                <input type="text" name="name" required v-model="glossaryData.name" data-error-message="Fill in this field." />
                            </div>
                        </div>
                        <div class="step-border">
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>2.</span>Fill in with the Basic Info</label>
                            </div>
                            <div class="modal-boxs-wrapper">
                                <div class="modal-input col-100">
                                    <label for="full-description">Full description</label>
                                    <input type="text" name="full-description" required v-model="glossaryData.description" data-error-message="Fill in this field." />
                                </div>
                                <div class="modal-input col-100">
                                    <label for="short-description">Short description</label>
                                    <input type="text" name="short-description" required v-model="glossaryData.summary" data-error-message="Fill in this field." />
                                </div>
                                <div class="modal-input col-100">
                                    <label for="language">Language</label>
                                    <input type="text" name="language" id="language" required v-model="glossaryData.language" data-error-message="Fill in this field." />
                                </div>
                                <div class="modal-input col-100">
                                    <label for="usage">Usage</label>
                                    <input type="text" name="usage" id="usage" required v-model="glossaryData.usage" data-error-message="Fill in this field." />
                                </div>
                            </div>
                            <div class="field field-modal-big-label">
                                <label for="" class="label"><span>3.</span>Set the relations for this Glossary</label>
                            </div>
                            <div class="modal-boxs-wrapper">
                                <div class="modal-box col">
                                    <div class="modal-box-search">
                                        <h3>Domains</h3>
                                        <div class="search-wrapper">
                                            <input type="text" name="platform-search" class="input-search">
                                        </div>
                                    </div>
                                    <ul class="modal-box-checkbox-list modal-box-checkbox-list-ball">
                                        <li v-for="domain in domains2" :key="domain?.name">
                                            <input type="checkbox" :id="`domain-${domain?.name}`" :value="domain"
                                            :checked="checkedDomains.includes(domain)"
                                            @change="toggleDomainSelection(domain)" />
                                            <label :for="`domain-${domain?.name}`">{{ domain?.name }}</label>
                                        </li>
                                    </ul>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>

                <!-- ==== STEP 2 - Confirmation === -->
                <div id="step-2" class="step" v-show="currentStep === 2">
                    <div class="title">
                        <span class="step-number">2</span>
                        <h2>Confirmation</h2>
                        <p>Your glossary has been created. Please review the details below to confirm everything is correct.</p>
                    </div>
                    <div class="confirmation-wrapper">
                        <div class="confirmation-wrapper-values">
                            <div class="card-values">
                                <div class="card-values-number">{{ domainsCount }}</div>
                                <div class="card-values-text">Domains</div>
                            </div>
                        </div>
                        <button class="button-secondary orange" @click="closeModal">Confirm Details</button>
                    </div>
                </div>

            </div>
            <div class="modal-buttons-area">
                <button :class="['button-stroke-transparent rounded', currentStep === 1 && 'hide']" id="previous-step"
                    @click="previousStep">Back</button>
                <button class="button-secondary orange" id="next-step" @click="handleNextClick"
                    v-if="currentStep !== 2">Create</button>
            </div>
        </div>
    </div>
    <ClientOnly>
        <Teleport to="#modals-container">
            <ModalsModalFeedback v-if="showFeedback" :feedback="feedbackMessage" @toggle="close"/>
        </Teleport>
    </ClientOnly>
</template>
<script setup lang="ts">
import { removeHtmlTags } from '~/utils/utils';

const props = defineProps({
    row: { 
        type: undefined as any, 
        required: false 
    },
    isEditMode: {
        type: Boolean,
        required: false
    }
});

const emit = defineEmits(['toggle', 'refresh-data']);

const closeModal = () => {
    emit('toggle');
    emit('refresh-data');
}

const feedbackMessage = ref({ type: '', message: '' });
const showFeedback = ref(false);
const close = () => {
    showFeedback.value = false;
};

interface Domain {
  name: string;
} 

interface Glossary {
    id: number;
    name: string;
    type: string;
    group: string;
    domains: any;
    description: string;
    updatedAt: string;
    createdAt: string;
    terms: any
}

const currentStep = ref<number>(1);
const checkedDomains = ref<Domain[]>([]);
const domainsCount = computed(() => checkedDomains.value.length);
const domains2 = ref<Domain[]>([]);
const terms = ref<any[]>([]);
const glossaryData = ref({
    name: '',
    description: '',
    summary: '',
    usage: '',
    language: '',
    id: '',
    terms: [],
    createdAt: '',
    updatedAt: '',
    domains: [] as string[],
}); 

// **Toggle Selection Function for Domains**
const toggleDomainSelection = (domain: Domain) => {
   const index = checkedDomains.value.findIndex(d => d.name === domain.name);
   if (index > -1) {
      checkedDomains.value.splice(index, 1);
   } else {
      checkedDomains.value.push(domain);
   }
};

// form submit step 1
const handleSubmit = () => {
    const form = document.getElementById('glossary-step-1') as HTMLFormElement;

    if (form && form?.checkValidity()) {

        const formData = new FormData(form);

        const data = {
            name: formData.get('name') as string,
            description: formData.get('full-description') as string,
            summary: formData.get('short-description') as string,
            usage: formData.get('usage') as string,
            language: formData.get('language') as string
        };

        try {
            if(props?.isEditMode){
                submitDataUpdate(data, props?.row);
            } else {
                submitData(data);
                form.reset();
            }
            
            console.log('Data submitted successfully: (request)', data);

            // Clear the form and validation errors after successful submission
            
            clearAllValidationErrors(form);
            //nextStep();
        } catch (error) {
            console.error('Error during data submission:', error);
        }

        

    } else {
        highlightInvalidFields(form);
        console.log('Form is invalid, show error messages or handle accordingly.');
    }
}

// **Submit New Glossary**
const submitData = async (data: any) => {
    try {

        useFetchAuth('/glossaries', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify(data)
        }).then((response: any) => {
            for (var i = 0; i < checkedDomains.value.length; i++) {
                associateDomains(checkedDomains.value[i]?.name, response.id);
            }
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'success',
                message: 'Glossary added successfully!',
            };
            setTimeout(() => {
                feedbackMessage.value = { type: '', message: '' };
                showFeedback.value = false;
                nextStep();
            }, 3000);
        }).catch((error) => {
            const errorData = error.response._data.message || error;
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'Error adding glossary:' + errorData,
            };
        }); 

    } catch (error) {
        showFeedback.value = true;
        feedbackMessage.value = {
            type: 'error',
            message: 'Error adding glossary:' + error,
        };
        console.error('Error during fetch:', error);
    }
}

// **Submit Updated Glossary**
const submitDataUpdate = async (data: any, id: string) => {
    try {
        const responseOld = await useFetchAuth(`/glossaries/${id}`) as { domains: any };
        
        if (responseOld?.domains?.length) {
            await Promise.all(
                responseOld.domains.map((domain: any) => removeAssociatedDomains(domain, id))
            );
        }

        useFetchAuth('/glossaries/' + id, { 
            method: 'PUT',
            headers: {
            'Content-Type': 'application/json'
            },
            body: JSON.stringify(data)
        }).then((response: any) => {
            for (var i = 0; i < checkedDomains.value.length; i++) {
                associateDomains(checkedDomains.value[i]?.name, response.id);
            }
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'success',
                message: 'Glossary updated successfully!',
            };
            setTimeout(() => {
                feedbackMessage.value = { type: '', message: '' };
                showFeedback.value = false;
                nextStep();
            }, 3000);
        }).catch((error) => {
            const errorData = error.response._data.message || error;
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'Error updating glossary:' + errorData,
            };
        });
    } catch (error) {
        showFeedback.value = true;
        feedbackMessage.value = {
            type: 'error',
            message: 'Error updating glossary:' + error,
        };
        console.error('Error during update:', error);
    }
}

const handleNextClick = () => {
    if (currentStep.value === 1) {
        // Trigger form submission and validation only on step 1
        handleSubmit();
    } else {
        // Proceed to the next step without form submission
        nextStep();
    }
}

const nextStep = () => {
    if (currentStep.value < 2) {
        currentStep.value++;
    }
}

const previousStep = () => {
    if (currentStep.value > 0) {
        currentStep.value--;
    }
}

const gotoStep = (step: number) => {
    currentStep.value = step;
}

// GET ALL TERMS

useFetchAuth('/glossaries')
.then(async (response: any) => {
    const glossary: Glossary[] = response;

    // Map the response data to match the structure of `rows`
    const rows = glossary.map((term: Glossary, index: number) => ({
        id: term.id,
        name: term.name,
        type: 'Term'
    }));

    // Map all terms to `rows`
    glossary.forEach((term: any) => {
        for (let i = 0; i < term.terms.length; i++) {

            terms.value.push({
                id: term.terms[i].id,
                name: term.terms[i].name,
                type: 'Term',
            });
        }
    });
})
.catch(error => {
    console.error('API Error:', error);
});

// GET ALL DOMAINs


useFetchAuth('/domains')
.then(async (response: any) => {
    const domains: Domain[] = response;
    domains2.value = domains;

    if (props.isEditMode && props.row) {
        fetchGlossaryDetails(props.row);
    }
})
.catch(error => {
    console.error('API Error:', error);
});



const fetchGlossaryDetails = async (id: string) => {
    try {
        const response = await useFetchAuth('/glossaries/' + id, { 
            method: 'GET',
            headers: {
            'Content-Type': 'application/json'
            }
        });

        if (response !== null) {
            const data = Array.isArray(response) ? response[0] : response;
            if(props.isEditMode && props.row){
                glossaryData.value = {
                    name: data.name || '',
                    description: removeHtmlTags(data.description) || '',
                    summary: data.summary || '',
                    usage: data.usage || '',
                    language: data.language || '',
                    id: data.id || '',
                    terms: data.terms || [],
                    createdAt: data.createdAt || '',
                    updatedAt: data.updatedAt || '',
                    domains: data.domains || [],
                }
            }else{
                glossaryData.value = {
                    name: '',
                    description: '',
                    summary: '',
                    usage: '',
                    language: '',
                    id: '',
                    terms: [],
                    createdAt: '',
                    updatedAt: '',
                    domains: [],
                }
            }
            

            // Update the checkedDomains based on glossaryData.domains and available domains2
            checkedDomains.value = domains2.value.filter((domain: any) =>
                glossaryData.value.domains.includes(domain.name)  // Check if the domain exists in glossaryData.domains
            );

            console.log('Data fetched successfully');
        } else {
            console.error('Error fetching data');
        }
    } catch (error) {
        console.error('Error during fetch:', error);
    }
}

</script>